/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-domimpl.h
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 * Copyright (C) 2000 Anders Carlsson <andersca@gnu.org>
 * Copyright (C) 2001 Paolo Casarini <paolo@casarini.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

/* ----------------------------------------------------------------- */
/* ----------------------  DOMImplementation  ---------------------- */
/* ----------------------------------------------------------------- */

#ifndef GDOME_DOMIMPL_FILE
#define GDOME_DOMIMPL_FILE

typedef struct _Gdome_xml_DOMImplementation Gdome_xml_DOMImplementation;

struct _Gdome_xml_DOMImplementation {
	GdomeDOMImplementation super;
	int refcnt;
};

GdomeDOMImplementation * gdome_xml_DOMImplementation_mkref (void);

GdomeBoolean   gdome_xml_DOMImplementation_hasFeature (GdomeDOMImplementation *self,
																											 GdomeDOMString *feature,
																											 GdomeDOMString *version,
																											 GdomeException *exc);

GdomeDocumentType *gdome_xml_DOMImplementation_createDocumentType (GdomeDOMImplementation *self,
																																	 GdomeDOMString *qualifiedName,
																																	 GdomeDOMString *publicId,
																																	 GdomeDOMString *systemId,
																																	 GdomeException *exc);

GdomeDocument *gdome_xml_DOMImplementation_createDocument (GdomeDOMImplementation *self,
																													 GdomeDOMString *namespaceURI,
																													 GdomeDOMString *qualifiedName,
																													 GdomeDocumentType *doctype,
																													 GdomeException *exc);

void           gdome_xml_DOMImplementation_ref (GdomeDOMImplementation *self,
																								GdomeException *exc);

void           gdome_xml_DOMImplementation_unref (GdomeDOMImplementation *self,
																									GdomeException *exc);
void         * gdome_xml_DOMImplementation_query_interface (GdomeDOMImplementation *self,
																														const char *interface, GdomeException *exc);

GdomeDocument * gdome_xml_DOMImplementation_parseFile (GdomeDOMImplementation *self,
                                                       const char *uri,
                                                       GdomeException *exc);
GdomeDocument * gdome_xml_DOMImplementation_validateFile (GdomeDOMImplementation *self,
                                                          const char *uri,
                                                          GdomeException *exc);
GdomeBoolean    gdome_xml_DOMImplementation_saveFile  (GdomeDOMImplementation *self,
                                                       const char *filename,
                                                       GdomeDocument *doc,
                                                       GdomeException *exc);
void            gdome_xml_DOMImplementation_freeDoc   (GdomeDOMImplementation *self,
                                                       GdomeDocument *doc,
                                                       GdomeException *exc);
GdomeBoolean    gdome_xml_DOMImplementation_saveFile  (GdomeDOMImplementation *self,
                                                       const char *filename,
                                                       GdomeDocument *doc,
                                                       GdomeException *exc);
GdomeBoolean    gdome_xml_DOMImplementation_saveFormatFile  (GdomeDOMImplementation *self,
                                                             const char *filename,
                                                             GdomeDocument *doc,
                                                             int format,
                                                             GdomeException *exc);

const GdomeDOMImplementationVtab gdome_xml_DOMImplementation_vtab;



#endif /* GDOME_DOMIMPL_FILE */


